clear all;
close all;
clc;

tol = 1e-10;

%% test myLegendre_foreward %%
P0 = @(x) ones(1,length(x));
P1 = @(x) x;
P2 = @(x) 3/2*x.^2 - 1/2;
P3 = @(x) 5/2*x.^3 - 3/2*x;
P4 = @(x) 35/8*x.^4 - 30/8*x.^2 + 3/8;
P5 = @(x) 1/8*(63*x.^5 - 70*x.^3 + 15*x);
P6 = @(x) 1/16*(231*x.^6 - 315*x.^4 + 105*x.^2 - 5);

Q0 = @(x) 0.5*log((x+1)./(x-1));
Q1 = @(x) x/2.*log((x+1)./(x-1))-1;

n=6;
x = linspace(-1.5,1.5,256);
P = myLegendre_foreward(n,x,P0,P1);
Q = myLegendre_foreward(n,x,Q0,Q1);

%check result
errP = zeros(1,n+1);
errQ = zeros(1,2);

errP(1) = max(abs(P0(x)-P(1,:)));
errP(2) = max(abs(P1(x)-P(2,:)));
errP(3) = max(abs(P2(x)-P(3,:)));
errP(4) = max(abs(P3(x)-P(4,:)));
errP(5) = max(abs(P4(x)-P(5,:)));
errP(6) = max(abs(P5(x)-P(6,:)));
errP(7) = max(abs(P6(x)-P(7,:)));
errQ(1) = max(abs(Q0(x)-Q(1,:)));
errQ(2) = max(abs(Q1(x)-Q(2,:)));

err = max(max(([errP, errQ])));
if (err < tol)
    fprintf('Calculation of Pn and Qn: Passed\n.')
else
    fprintf(2,'Calculation of Pn and Qn: Failed.\n')
end


%% plot Pn and Qn for n in {0,1,2,3,4,5}

% ToDo4u
